#!/bin/sh

mem=$[`grep MemTotal /proc/meminfo | sed 's/[^0-9]//g'`*2]
[ -n "$mem" ] || mem=0

# if < 4Gb then swap is mem * 1.5, otherwize mem
if [ $mem -ge 8388608 ]; then
	swap_size=$[$mem]
else
	swap_size=$[$mem*3/2]
fi

max_disk=$(cat /sys/block/{hd,sd,vd,nvme,mmcblk}*/size 2>/dev/null | sort -n -r | head -1)
[ -n "$max_disk" ] || max_disk=0

# 16Gb
[ $swap_size -ge 33554432 ] && swap_size=33554432

{
cat << _EOF_
(
_EOF_
# max_disk >= 20G + 'swap'
cat << _EOF_
 (regular1
  (title . "Auto ext4 ('swap' + '/')")
  (actiondata
_EOF_
if [ `arch` = 'e2k' ]; then
# see also http://bugzilla.altlinux.org/34600
cat << _EOF_
   ("/boot" (size 2097152 . 2097152 ) (fsim . "Ext2/3") (methods plain))
_EOF_
fi
cat << _EOF_
   ("swap" (size $swap_size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("/" (size 41943040 . #t ) (fsim . "Ext2/3") (methods plain))
  )
 )
_EOF_
# if max_disk >= 120G; then / is 50Gb, /home >= 50G
if [ "$max_disk" -ge 251658240 ] ; then
cat << _EOF_
 (regular2
  (title . "Auto ext4 ('swap' + '/' + '/home')")
  (actiondata
_EOF_
if [ `arch` = 'e2k' ]; then
# see also http://bugzilla.altlinux.org/34600
cat << _EOF_
   ("/boot" (size 2097152 . 2097152 ) (fsim . "Ext2/3") (methods plain))
_EOF_
fi
cat << _EOF_
   ("swap" (size $swap_size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("/" (size 105000000 . 105000000 ) (fsim . "Ext2/3") (methods plain))
   ("/home" (size 105000000 . #t) (fsim . "Ext2/3") (methods plain))
  )
 )
_EOF_
fi
if which btrfs >/dev/null 2>&1; then
cat << _EOF_
 (regular3
  (title . "Auto btrfs ('swap' + '/' + '/home')")
  (actiondata
_EOF_
if [ `arch` = 'e2k' ]; then
# see also http://bugzilla.altlinux.org/34600
cat << _EOF_
   ("/boot" (size 2097152 . 2097152 ) (fsim . "Ext2/3") (methods plain))
_EOF_
fi
cat << _EOF_
   ("swap" (size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("" (size 41943040 . #t ) (fsim . "BtrFS") (methods plain)
    (subvols ("@" . "/") ("@home" . "/home")))
  )
 )
_EOF_
fi
cat << _EOF_
)
_EOF_
} > /var/cache/alterator/vm-profile.scm
